<?php // -*-c++-*-

# debug mode, don't do that on a live service
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

require __DIR__ . '/vendor/autoload.php';

use Jumbojett\OpenIDConnectClient;

session_start();

if(isset($_SESSION['oidc'])) {
  $oidc=$_SESSION['oidc'];

  try {
    $id=$oidc->requestUserInfo('email');
  } catch(Exception $e) {
    try {
      $oidc->authenticate();
      $id=$oidc->requestUserInfo('email');
    } catch(Exception $e) {
      echo "reauthentication failed.";
      exit(0);
    }
  }

  if(!isset($id)) {
    echo "could not get login name from oidc session\n";
    exit(0);
  }

# if we are on the first request from the oidc provider, send a redirect
  if(isset($_GET['code'])) {
    header("Location: .");
    exit(0);
  }
} else {

  try {
    $oidc = new OpenIDConnectClient('https://id.tilde.green/realms/tgci',
				    'CLIENTID',
				    'CLIENTSECRET');
    $oidc->authenticate();
    #$name = $oidc->requestUserInfo('user_id');
  } catch (Exception $e) {
    echo '<pre>Caught exception: ',  $e->getMessage(), "\n";
    echo $e->getTraceAsString(), "</pre>\n";
    exit(0);
  }
  $_SESSION['oidc']=$oidc;

  if(isset($_GET['code'])) {
    header("Location: .");
    exit(0);
  }
}

